///////////////////////////////////////////////////////////////////////////////
//
//                          IMPORTANT NOTICE
//
// The following open source license statement does not apply to any
// entity in the Exception List published by FMSoft.
//
// For more information, please visit:
//
// https://www.fmsoft.cn/exception-list
//
//////////////////////////////////////////////////////////////////////////////
/*
 *   This file is part of MiniGUI, a mature cross-platform windowing 
 *   and Graphics User Interface (GUI) support system for embedded systems
 *   and smart IoT devices.
 * 
 *   Copyright (C) 2002~2018, Beijing FMSoft Technologies Co., Ltd.
 *   Copyright (C) 1998~2002, WEI Yongming
 * 
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *   Or,
 * 
 *   As this program is a library, any link to this program must follow
 *   GNU General Public License version 3 (GPLv3). If you cannot accept
 *   GPLv3, you need to be licensed from FMSoft.
 * 
 *   If you have got a commercial license of this program, please use it
 *   under the terms and conditions of the commercial license.
 * 
 *   For more information about the commercial license, please refer to
 *   <http://www.minigui.com/blog/minigui-licensing-policy/>.
 */

#include "common.h"

#ifdef _MGINCORE_RES

//data of "skin_pushbtn.gif"

const unsigned char _mgir_gif_skin_pushbtn_data[]={
	0x47,0x49,0x46,0x38,0x39,0x61,0x14,0x00,	0x73,0x00,0xF7,0x00,0x00,0xC0,0xC1,0xC0,
	0xBE,0xBF,0xBE,0xCD,0xCE,0xCC,0xB6,0xB7,	0xB5,0xAE,0xAF,0xAD,0xCF,0xD0,0xCC,0x9E,
	0xC7,0x00,0x9C,0xC4,0x00,0x9A,0xC2,0x00,	0x98,0xBF,0x00,0x96,0xBD,0x00,0x95,0xBA,
	0x00,0x93,0xB8,0x00,0x91,0xB6,0x00,0x90,	0xB4,0x00,0x8E,0xB3,0x00,0x8D,0xB1,0x00,
	0x8A,0xAE,0x00,0x89,0xAC,0x00,0x80,0xA2,	0x00,0x7F,0x9F,0x00,0x7D,0x9D,0x00,0x7B,
	0x9B,0x00,0x7A,0x99,0x00,0x79,0x97,0x00,	0x77,0x95,0x00,0x74,0x91,0x00,0x6B,0x87,
	0x00,0x45,0x57,0x00,0x44,0x55,0x00,0x43,	0x54,0x00,0x42,0x53,0x00,0x41,0x52,0x00,
	0x41,0x51,0x00,0x94,0xB5,0x11,0x92,0xB3,	0x14,0x81,0x9D,0x14,0xB0,0xD4,0x23,0xAE,
	0xD1,0x23,0xA9,0xCB,0x22,0xA4,0xC5,0x21,	0xAB,0xCE,0x23,0xA6,0xC8,0x22,0xA2,0xC3,
	0x21,0x9D,0xBC,0x20,0xA0,0xC0,0x21,0x9E,	0xBE,0x21,0x9B,0xBA,0x20,0x4A,0x59,0x11,
	0xB5,0xD6,0x31,0xB3,0xD3,0x30,0xB5,0xD6,	0x32,0xB7,0xD8,0x33,0xBB,0xDC,0x35,0xB9,
	0xDB,0x35,0xBB,0xDC,0x36,0xA2,0xC0,0x2F,	0xBE,0xE1,0x38,0xBC,0xDF,0x37,0xC0,0xE2,
	0x3A,0xC2,0xE4,0x3B,0xA0,0xBC,0x31,0xC3,	0xE5,0x3C,0xBE,0xDF,0x3B,0xC4,0xE5,0x3D,
	0x9A,0xB4,0x30,0xBF,0xE0,0x3D,0x9C,0xB7,	0x32,0x9E,0xB9,0x33,0xA1,0xBC,0x35,0xA3,
	0xBF,0x37,0xAF,0xCD,0x3C,0xA5,0xC1,0x38,	0xA7,0xC2,0x3A,0xAB,0xC7,0x3E,0xAA,0xC5,
	0x3E,0xA0,0xBB,0x3B,0xB1,0xCD,0x44,0xA3,	0xBC,0x3E,0xC3,0xE1,0x4E,0xC1,0xDF,0x4D,
	0xC6,0xE4,0x50,0xC4,0xE1,0x4F,0xC8,0xE6,	0x51,0xCD,0xEB,0x54,0xCB,0xE9,0x53,0xC8,
	0xE6,0x52,0xD1,0xF0,0x57,0xCF,0xED,0x56,	0xD2,0xF1,0x58,0xD3,0xF3,0x5A,0x8E,0xA2,
	0x3C,0xD4,0xF3,0x5B,0xD6,0xF5,0x5C,0xD5,	0xF4,0x5C,0x8E,0xA3,0x3E,0xD3,0xF1,0x61,
	0xD6,0xF3,0x64,0x6E,0x7D,0x34,0x70,0x7F,	0x36,0x72,0x81,0x37,0x73,0x82,0x38,0x74,
	0x83,0x3A,0x7A,0x89,0x3F,0x79,0x88,0x3F,	0x72,0x80,0x3B,0x76,0x84,0x3F,0xA9,0xBD,
	0x5D,0xAB,0xBE,0x60,0x7F,0x8D,0x49,0x70,	0x7B,0x44,0xB3,0xC4,0x6F,0xB5,0xC6,0x71,
	0xB5,0xC6,0x73,0xD3,0xE6,0x89,0xD3,0xE6,	0x8A,0x8C,0x99,0x5D,0xA7,0xB4,0x76,0x81,
	0x89,0x62,0xD1,0xD2,0xCD,0xA2,0xBC,0x35,	0x6A,0x77,0x30,0x6D,0x7B,0x33,0x74,0x81,
	0x3E,0x74,0x7E,0x49,0x9A,0xA2,0x79,0x8E,	0x93,0x76,0x90,0x95,0x79,0xE8,0xFA,0x82,
	0xE9,0xFB,0x86,0xEB,0xFD,0x89,0xEC,0xFD,	0x8B,0xED,0xFE,0x8D,0xEE,0xFF,0x90,0xEA,
	0xFA,0x8F,0xEB,0xFB,0x94,0xE1,0xEC,0xA7,	0xE1,0xEC,0xA9,0xC3,0xDA,0x26,0xC4,0xDB,
	0x28,0xC5,0xDC,0x2B,0xC7,0xDE,0x2E,0xC8,	0xDF,0x31,0xCA,0xE1,0x34,0xCC,0xE3,0x37,
	0xC4,0xD9,0x36,0xCE,0xE5,0x3B,0xC6,0xDB,	0x39,0xD0,0xE7,0x3E,0xD2,0xE9,0x42,0xD4,
	0xEB,0x46,0xDE,0xF0,0x6C,0xDF,0xF2,0x70,	0xE0,0xF2,0x71,0xE1,0xF4,0x74,0xE3,0xF5,
	0x78,0xE5,0xF7,0x7B,0xE7,0xF9,0x7F,0xC9,	0xD6,0x72,0xCA,0xD6,0x78,0xCA,0xD6,0x76,
	0xD1,0xD1,0xCD,0xD2,0xD2,0xCF,0xCE,0xCE,	0xCC,0xDE,0xDE,0xDD,0xD8,0xD8,0xD7,0xD1,
	0xD1,0xD0,0xC3,0xC3,0xC2,0xBE,0xBE,0xBD,	0xBB,0xBB,0xBA,0xB9,0xB9,0xB8,0xB4,0xB4,
	0xB3,0xB3,0xB3,0xB2,0xB2,0xB2,0xB1,0xB0,	0xB0,0xAF,0xAD,0xAD,0xAC,0x4E,0x45,0x44,
	0x47,0x3D,0x3C,0x1B,0x05,0x04,0x1F,0x06,	0x05,0x30,0x18,0x17,0x63,0x3E,0x3D,0x64,
	0x3F,0x3E,0x60,0x3E,0x3D,0x61,0x3F,0x3E,	0x68,0x10,0x0F,0x63,0x0F,0x0E,0x6D,0x12,
	0x10,0x7D,0x16,0x14,0x78,0x15,0x13,0x73,	0x13,0x12,0x19,0x04,0x04,0x1E,0x05,0x05,
	0x81,0x17,0x16,0x90,0x1B,0x19,0x89,0x1A,	0x18,0x85,0x18,0x17,0x1D,0x05,0x05,0x8D,
	0x1A,0x19,0x21,0x06,0x06,0x8F,0x29,0x27,	0x96,0x2C,0x2A,0x7B,0x3B,0x3A,0x78,0x3B,
	0x3A,0x79,0x3C,0x3B,0x75,0x3B,0x3B,0x71,	0x3B,0x3A,0x72,0x3C,0x3B,0x6E,0x3B,0x3B,
	0x6F,0x3C,0x3C,0x6C,0x3C,0x3C,0x69,0x3C,	0x3B,0x68,0x3D,0x3C,0x65,0x3D,0x3D,0xAD,
	0x6C,0x6B,0xA8,0x6B,0x6A,0xAC,0x6E,0x6D,	0x57,0x3C,0x3C,0x55,0x3D,0x3D,0x43,0x32,
	0x32,0x5C,0x45,0x45,0x44,0x35,0x35,0x43,	0x36,0x36,0x44,0x39,0x39,0x46,0x3B,0x3B,
	0x75,0x66,0x66,0x47,0x3E,0x3E,0x48,0x3F,	0x3F,0x52,0x49,0x49,0x7C,0x76,0x76,0x7E,
	0x79,0x79,0xCF,0xCD,0xCD,0xCD,0xCC,0xCC,	0xE5,0xE5,0xE5,0xE2,0xE2,0xE2,0xE0,0xE0,
	0xE0,0xDC,0xDC,0xDC,0xDA,0xDA,0xDA,0xD5,	0xD5,0xD5,0xD3,0xD3,0xD3,0xBD,0xBD,0xBD,
	0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x21,0xF9,0x04,
	0x01,0x00,0x00,0xF1,0x00,0x2C,0x00,0x00,	0x00,0x00,0x14,0x00,0x73,0x00,0x00,0x08,
	0xFF,0x00,0xEF,0xCC,0x09,0xD3,0xA5,0xA0,	0xC1,0x83,0x07,0xC3,0xCC,0xB9,0x23,0xC7,
	0x8B,0xC3,0x87,0x10,0x23,0x3E,0x94,0x03,	0x46,0x8B,0x16,0x2E,0x16,0x33,0x62,0xD4,
	0x98,0x51,0x0B,0x98,0x2C,0x20,0x43,0x8A,	0x1C,0x39,0xF2,0x8A,0xC9,0x93,0x28,0x53,
	0xA6,0xC4,0xC2,0xB2,0xA5,0xCB,0x97,0x2F,	0xA9,0xC8,0x9C,0x49,0xB3,0x66,0xCD,0x2A,
	0x38,0x73,0xEA,0xDC,0xB9,0x73,0x8A,0x95,	0x29,0x3E,0xAD,0xFC,0x1C,0x0A,0x14,0xA8,
	0xD0,0xA0,0x51,0x92,0x2A,0x5D,0xCA,0x94,	0xA9,0x94,0xA7,0x4F,0xA2,0x3E,0x95,0xF2,
	0x64,0xAA,0xD5,0xA9,0x50,0xB2,0x6A,0xDD,	0xCA,0x95,0x6B,0x89,0xAF,0x60,0xC3,0x8A,
	0x15,0x6B,0xA2,0xAC,0xD9,0xB3,0x68,0xD1,	0xA6,0x58,0xCB,0xB6,0xAD,0x5B,0xB7,0x27,
	0xE2,0xCA,0x9D,0x4B,0x97,0xAE,0x8A,0xBB,	0x78,0xF3,0xEA,0xD5,0x8B,0xA2,0xAF,0xDF,
	0xBF,0x80,0x01,0xAF,0x18,0x4C,0xB8,0xB0,	0x61,0xC3,0x2D,0x12,0x2B,0x5E,0xCC,0x98,
	0x31,0x0E,0x17,0x90,0x23,0x4B,0x9E,0x1C,	0x19,0x47,0x1C,0x16,0x98,0x33,0x6B,0xDE,
	0x9C,0x19,0x4E,0x81,0x37,0x3D,0x5E,0x88,	0x1E,0x4D,0x9A,0x74,0x8F,0x37,0x05,0x44,
	0x25,0x3A,0x54,0xA8,0xB5,0xEB,0xD7,0xAF,	0x0F,0x25,0x12,0x85,0x88,0x90,0xED,0xDB,
	0xB8,0x73,0xDF,0x46,0x64,0x68,0x90,0xEF,	0xDF,0xC0,0x83,0xFF,0x36,0x24,0xA8,0xB8,
	0xF1,0xE3,0xC8,0x91,0x07,0x5A,0xCE,0xBC,	0xB9,0x73,0xE7,0x80,0xA2,0x4B,0x9F,0x4E,
	0x9D,0x7A,0xA7,0xEB,0xD8,0xB3,0x6B,0xD7,	0xCE,0xA9,0xBB,0xF7,0xEF,0xE0,0xC1,0x6F,
	0xFF,0x1A,0x4F,0xBE,0xBC,0x79,0xF3,0x9A,	0xD2,0xAB,0x5F,0xCF,0x9E,0x7D,0xA6,0xF7,
	0x98,0xE2,0xBF,0xCF,0x84,0x69,0xBE,0xFD,	0xF9,0x97,0xF2,0xEB,0xDF,0xCF,0x9F,0xBF,
	0xA5,0xFF,0x00,0x06,0x28,0xA0,0x80,0x95,	0x14,0x68,0xE0,0x81,0x08,0x22,0x48,0xC9,
	0x82,0x0C,0x36,0xE8,0xA0,0x83,0x92,0x44,	0x28,0xE1,0x84,0x14,0x52,0x08,0xC9,0x85,
	0x18,0x66,0xA8,0xA1,0x86,0x8F,0x74,0xE8,	0xE1,0x87,0x20,0x82,0xE8,0xC8,0x88,0x24,
	0x96,0x68,0xA2,0x89,0x8D,0xA4,0xA8,0xE2,	0x8A,0x2C,0xB2,0x38,0x09,0x23,0x30,0xC6,
	0x28,0xE3,0x8C,0x31,0x4E,0xF2,0xC9,0x22,	0x38,0xE6,0xA8,0xE3,0x8E,0x39,0x82,0x12,
	0x8A,0x27,0x91,0x28,0x22,0xE4,0x90,0x44,	0x12,0x19,0x89,0x27,0xA1,0x08,0xF0,0x07,
	0x1F,0x6A,0xA0,0x71,0xC6,0x93,0x50,0x46,	0xF9,0x64,0x1B,0x7D,0x8C,0xE2,0xC7,0x1E,
	0x5F,0x38,0xB1,0x84,0x12,0x5C,0x76,0xE9,	0x25,0x97,0x4B,0x38,0x51,0x87,0x1B,0x5B,
	0x1C,0x21,0x84,0x0F,0x68,0xA2,0x09,0x44,	0x9A,0x3E,0xAC,0x89,0xA6,0x10,0x4D,0xA4,
	0xC1,0xC4,0x0F,0x3C,0xD4,0x69,0xE7,0x9D,	0x78,0xF2,0xF0,0x83,0x19,0x49,0xEC,0xE0,
	0xE7,0x9F,0x80,0x06,0xFA,0x67,0x19,0x48,	0xE4,0x60,0xE8,0xA1,0x88,0x26,0x7A,0x28,
	0x19,0x46,0xE8,0xE0,0xE8,0xA3,0x90,0x46,	0xFA,0xE8,0x18,0x78,0xDC,0x60,0xA9,0xA5,
	0x35,0x5C,0xAA,0xE9,0xA6,0x62,0x14,0x61,	0xC3,0xA7,0xA0,0x86,0x2A,0x2A,0xA8,0x7A,
	0x10,0x41,0xC3,0xA9,0xA8,0xA6,0xAA,0x2A,	0xAA,0x7A,0x0C,0x31,0x43,0x0C,0xB0,0xCE,
	0xFF,0x20,0x6B,0x0C,0xB2,0xD6,0x6A,0xEB,	0x0C,0x79,0x04,0x21,0xC3,0xAE,0xBC,0xF6,
	0xEA,0x2B,0xAF,0x1C,0x4C,0x60,0xC0,0xB0,	0xC4,0x16,0x6B,0x2C,0xB1,0x1C,0x50,0x70,
	0xC0,0xB2,0xCC,0x36,0xEB,0x2C,0xB3,0x1D,	0x54,0x80,0xC0,0xB4,0xD4,0x56,0x6B,0x2D,
	0xB5,0x1E,0x58,0x90,0xC0,0xB6,0xDC,0x76,	0xEB,0x2D,0xB7,0x1F,0x5C,0xA0,0xC0,0xB8,
	0xE4,0x96,0x6B,0x2E,0xB9,0x20,0x60,0xB0,	0xC0,0xBA,0xEC,0xB6,0xEB,0x2E,0xBB,0x21,
	0x64,0xC0,0xC0,0xBC,0xF4,0xD6,0x6B,0x2F,	0xBD,0xF1,0x36,0xA0,0xEF,0xBE,0xFC,0xF6,
	0xBB,0x2F,0x0C,0x1A,0x3C,0xE0,0xC0,0xC0,	0x04,0x17,0x6C,0xB0,0x03,0x22,0xD8,0xB1,
	0x41,0x04,0x0F,0x34,0xEC,0xF0,0xC3,0x10,	0x3F,0xC0,0x86,0x00,0x74,0x90,0x20,0x01,
	0x04,0x18,0x67,0xAC,0x71,0xC6,0x23,0xAC,	0x51,0x80,0x29,0xEC,0xA4,0x23,0xF2,0xC8,
	0x24,0x97,0x9C,0x0E,0x3B,0x20,0x9B,0xAC,	0x72,0xC9,0xEC,0xA8,0xE3,0xF2,0xCB,0x30,
	0xC7,0x2C,0xF3,0xCC,0x34,0xC3,0xBC,0xCE,	0xCD,0x38,0xE7,0xAC,0xB3,0xCE,0xA4,0xF4,
	0xEC,0xF3,0xCF,0x40,0x03,0xCD,0xCE,0xD0,	0x44,0x17,0x6D,0xB4,0xD1,0xED,0x24,0xAD,
	0xF4,0xD2,0x4C,0x33,0x5D,0xCA,0xD3,0x50,	0x47,0x2D,0xB5,0xD4,0xEE,0x54,0x6D,0xF5,
	0xD5,0x58,0x63,0xFD,0xCE,0xD6,0x5C,0x77,	0xED,0xB5,0xD7,0xA6,0x84,0x2D,0xF6,0xD8,
	0x64,0x93,0x7D,0xCA,0xD9,0x68,0xA7,0xAD,	0xB6,0xDA,0x00,0xB4,0xED,0xF6,0xDB,0x70,
	0xC3,0x8D,0xCA,0xDC,0x74,0xD7,0x6D,0xB7,	0xDD,0xA9,0xE4,0xAD,0xF7,0xDE,0x7C,0xF3,
	0xFF,0xAD,0xCA,0xDF,0x80,0x07,0x2E,0xB8,	0xE0,0x03,0x14,0x6E,0xF8,0xE1,0x88,0x23,
	0xBE,0xCA,0xE2,0x8C,0x37,0xEE,0xB8,0xE3,	0xAD,0x44,0x2E,0xF9,0xE4,0x94,0x53,0xCE,
	0x8A,0x2B,0x98,0x67,0xAE,0xF9,0xE6,0x99,	0xB3,0x12,0x00,0x01,0xA0,0x87,0x2E,0xFA,
	0xE8,0xA1,0x07,0x60,0x0A,0x3C,0xAE,0xBC,	0xA2,0xFA,0xEA,0xAC,0xB3,0xEE,0x0A,0x3C,
	0xA6,0xA0,0x63,0x0E,0x39,0xE3,0xD4,0x6E,	0xFB,0xED,0xB7,0x93,0x63,0x0E,0x3A,0xE5,
	0x88,0xE3,0xFB,0xEF,0xC0,0x07,0xFF,0x7B,	0x39,0xB0,0xC4,0xA2,0x0D,0x2E,0xB5,0x24,
	0x9F,0xBC,0x2D,0xCA,0xD7,0xC2,0x7C,0xF2,	0xB7,0x70,0x13,0x4B,0x36,0xD5,0x54,0x6F,
	0xFD,0xF5,0xD8,0x5B,0x0F,0x4E,0x35,0xD4,	0x74,0xEF,0xFD,0xF7,0xE0,0x7B,0xFF,0xCD,
	0x34,0xE4,0x97,0x6F,0xFE,0xF9,0xE6,0x7F,	0x23,0xCD,0xFA,0xEC,0xB7,0xEF,0x7E,0xFB,
	0xDF,0x40,0x13,0xCD,0xFC,0xF3,0xCB,0x4F,	0xFF,0xFD,0xF7,0x7B,0xF3,0x8C,0x33,0xCE,
	0x3C,0xE3,0x7F,0xFF,0x00,0xE4,0x5F,0xFF,	0xF6,0xE7,0xBF,0x6E,0x34,0xE3,0x80,0x08,
	0x4C,0xA0,0x02,0x13,0xD8,0x0D,0x66,0x30,	0x63,0x19,0x10,0x74,0xE0,0x03,0x25,0x48,
	0x41,0x09,0x6E,0x43,0x19,0x18,0xCC,0xA0,	0x06,0x37,0xA8,0xC1,0x5F,0xE8,0xE2,0x83,
	0x20,0x0C,0xA1,0x08,0x43,0xF8,0x8B,0x5C,	0x98,0xF0,0x84,0x28,0x4C,0x21,0x0A,0x65,
	0xB1,0x8B,0x16,0xBA,0xF0,0x85,0x30,0x7C,	0x61,0x31,0x7C,0x41,0xC3,0x1A,0xDA,0xF0,
	0x86,0x36,0x04,0x46,0x2F,0x76,0xC8,0xC3,	0x1E,0xFA,0xB0,0x87,0xB3,0xE0,0x85,0x10,
	0x40,0x87,0x48,0xC4,0x22,0x12,0xF1,0x18,	0xC1,0x48,0xA2,0x12,0x97,0xC8,0xC4,0x25,
	0x1E,0x83,0x18,0x50,0x8C,0xA2,0x14,0xA7,	0x28,0x45,0x5A,0x0C,0xE3,0x8A,0x58,0xCC,
	0xA2,0x16,0xB1,0x88,0x8C,0x70,0x18,0xE3,	0x8B,0x60,0x0C,0xA3,0x18,0xC1,0x88,0x0D,
	0x74,0x5C,0x23,0x19,0xC2,0x48,0xA3,0x1A,	0xD7,0xB8,0xC6,0x64,0x58,0xE3,0x1C,0x01,
	0x01,0x00,0x3B
};
#endif //_MGINCORE_RES

