///////////////////////////////////////////////////////////////////////////////
//
//                          IMPORTANT NOTICE
//
// The following open source license statement does not apply to any
// entity in the Exception List published by FMSoft.
//
// For more information, please visit:
//
// https://www.fmsoft.cn/exception-list
//
//////////////////////////////////////////////////////////////////////////////
/*
 *   This file is part of MiniGUI, a mature cross-platform windowing 
 *   and Graphics User Interface (GUI) support system for embedded systems
 *   and smart IoT devices.
 * 
 *   Copyright (C) 2002~2018, Beijing FMSoft Technologies Co., Ltd.
 *   Copyright (C) 1998~2002, WEI Yongming
 * 
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *   Or,
 * 
 *   As this program is a library, any link to this program must follow
 *   GNU General Public License version 3 (GPLv3). If you cannot accept
 *   GPLv3, you need to be licensed from FMSoft.
 * 
 *   If you have got a commercial license of this program, please use it
 *   under the terms and conditions of the commercial license.
 * 
 *   For more information about the commercial license, please refer to
 *   <http://www.minigui.com/blog/minigui-licensing-policy/>.
 */

#include "common.h"

#ifdef _MGINCORE_RES

//data of "skin_tb_vert.gif"

const unsigned char _mgir_gif_skin_tb_vert_data[]={
	0x47,0x49,0x46,0x38,0x39,0x61,0x0B,0x00,	0x54,0x00,0xF7,0x00,0x00,0xDC,0xDC,0xDC,
	0xDA,0xDA,0xDA,0xD9,0xD9,0xD9,0xD3,0xD3,	0xD3,0xD2,0xD2,0xD2,0xD1,0xD1,0xD1,0xD0,
	0xD0,0xD0,0xCF,0xCF,0xCF,0xCE,0xCE,0xCE,	0xCD,0xCD,0xCD,0xCC,0xCC,0xCC,0xCB,0xCB,
	0xCB,0xCA,0xCA,0xCA,0xC9,0xC9,0xC9,0xC8,	0xC8,0xC8,0xC7,0xC7,0xC7,0xC6,0xC6,0xC6,
	0xC5,0xC5,0xC5,0xC2,0xC2,0xC2,0xC0,0xC0,	0xC0,0xBF,0xBF,0xBF,0xBE,0xBE,0xBE,0xBD,
	0xBD,0xBD,0xBC,0xBC,0xBC,0xBB,0xBB,0xBB,	0xBA,0xBA,0xBA,0xB8,0xB8,0xB8,0xB7,0xB7,
	0xB7,0xB4,0xB4,0xB4,0xB2,0xB2,0xB2,0xB1,	0xB1,0xB1,0xB0,0xB0,0xB0,0xAF,0xAF,0xAF,
	0xAE,0xAE,0xAE,0xAC,0xAC,0xAC,0xA9,0xA9,	0xA9,0xA7,0xA7,0xA7,0xA6,0xA6,0xA6,0xA5,
	0xA5,0xA5,0xA3,0xA3,0xA3,0xA1,0xA1,0xA1,	0xA0,0xA0,0xA0,0x9E,0x9E,0x9E,0x9A,0x9A,
	0x9A,0x98,0x98,0x98,0x97,0x97,0x97,0x96,	0x96,0x96,0x95,0x95,0x95,0x94,0x94,0x94,
	0x93,0x93,0x93,0x90,0x90,0x90,0x8D,0x8D,	0x8D,0x8C,0x8C,0x8C,0x8B,0x8B,0x8B,0x89,
	0x89,0x89,0x88,0x88,0x88,0x85,0x85,0x85,	0x84,0x84,0x84,0x83,0x83,0x83,0x81,0x81,
	0x81,0x7F,0x7F,0x7F,0x7E,0x7E,0x7E,0x7C,	0x7C,0x7C,0x7B,0x7B,0x7B,0x7A,0x7A,0x7A,
	0x79,0x79,0x79,0x77,0x77,0x77,0x74,0x74,	0x74,0x72,0x72,0x72,0x71,0x71,0x71,0x70,
	0x70,0x70,0x6F,0x6F,0x6F,0x6D,0x6D,0x6D,	0x6C,0x6C,0x6C,0x6B,0x6B,0x6B,0x6A,0x6A,
	0x6A,0x68,0x68,0x68,0x67,0x67,0x67,0x65,	0x65,0x65,0x64,0x64,0x64,0x63,0x63,0x63,
	0x62,0x62,0x62,0x60,0x60,0x60,0x5F,0x5F,	0x5F,0x5E,0x5E,0x5E,0x5D,0x5D,0x5D,0x5C,
	0x5C,0x5C,0x5A,0x5A,0x5A,0x59,0x59,0x59,	0x58,0x58,0x58,0x57,0x57,0x57,0x56,0x56,
	0x56,0x54,0x54,0x54,0x53,0x53,0x53,0x52,	0x52,0x52,0x51,0x51,0x51,0x50,0x50,0x50,
	0x4F,0x4F,0x4F,0x4E,0x4E,0x4E,0x4D,0x4D,	0x4D,0x4C,0x4C,0x4C,0x4B,0x4B,0x4B,0x4A,
	0x4A,0x4A,0x49,0x49,0x49,0x48,0x48,0x48,	0x46,0x46,0x46,0x45,0x45,0x45,0x43,0x43,
	0x43,0x42,0x42,0x42,0x3E,0x3E,0x3E,0x3D,	0x3D,0x3D,0x3B,0x3B,0x3B,0x3A,0x3A,0x3A,
	0x39,0x39,0x39,0x38,0x38,0x38,0x37,0x37,	0x37,0x36,0x36,0x36,0x35,0x35,0x35,0x34,
	0x34,0x34,0x33,0x33,0x33,0x32,0x32,0x32,	0x31,0x31,0x31,0x30,0x30,0x30,0x2F,0x2F,
	0x2F,0x2E,0x2E,0x2E,0x2D,0x2D,0x2D,0x2C,	0x2C,0x2C,0x2B,0x2B,0x2B,0x2A,0x2A,0x2A,
	0x29,0x29,0x29,0x27,0x27,0x27,0x26,0x26,	0x26,0x25,0x25,0x25,0x22,0x22,0x22,0x21,
	0x21,0x21,0x20,0x20,0x20,0x1F,0x1F,0x1F,	0x1D,0x1D,0x1D,0x1C,0x1C,0x1C,0x1B,0x1B,
	0x1B,0x19,0x19,0x19,0x18,0x18,0x18,0x17,	0x17,0x17,0x16,0x16,0x16,0x15,0x15,0x15,
	0x14,0x14,0x14,0x13,0x13,0x13,0x12,0x12,	0x12,0x11,0x11,0x11,0x10,0x10,0x10,0x0F,
	0x0F,0x0F,0x0E,0x0E,0x0E,0x0D,0x0D,0x0D,	0x0C,0x0C,0x0C,0x07,0x07,0x07,0x06,0x06,
	0x06,0x05,0x05,0x05,0x04,0x04,0x04,0x03,	0x03,0x03,0xFF,0xFF,0xFF,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	0x00,0x00,0x00,0x00,0x00,0x21,0xF9,0x04,
	0x01,0x00,0x00,0x9F,0x00,0x2C,0x00,0x00,	0x00,0x00,0x0B,0x00,0x54,0x00,0x00,0x08,
	0xFF,0x00,0x1F,0x8C,0x69,0x34,0xE7,0xCC,	0x98,0x2E,0x51,0x6E,0x54,0x28,0xF0,0x45,
	0x13,0xA4,0x35,0x5E,0xB4,0x58,0x39,0xA2,	0x02,0xC2,0x81,0x4B,0x9C,0x20,0x25,0x32,
	0x24,0xA8,0x8F,0x1C,0x24,0x13,0x20,0x78,	0xDA,0xF4,0x68,0xE3,0xA0,0x3F,0x7B,0xD8,
	0x90,0xD8,0xD0,0x69,0x93,0xA3,0x45,0x86,	0x4E,0xEE,0xA9,0xB3,0xC2,0x43,0x27,0x4E,
	0x8D,0x12,0x15,0x22,0xF4,0x27,0x4F,0x9D,	0x16,0x20,0x5A,0x3E,0x5A,0x74,0x48,0xD0,
	0x1F,0x3D,0x75,0x58,0x80,0xF0,0xC4,0xC9,	0x91,0x4E,0x9E,0x48,0x5B,0x7C,0xB8,0x99,
	0x73,0x67,0xCF,0x3B,0x2D,0x42,0x08,0x5D,	0x84,0xC8,0xE8,0x4C,0xA0,0x2D,0x73,0x1A,
	0xE2,0xF9,0x55,0xAB,0x26,0x47,0x8A,0x38,	0xF6,0xB4,0x93,0x95,0x69,0xC9,0x98,0x47,
	0x7F,0x86,0x18,0xD9,0x48,0xD1,0x21,0xA8,	0x58,0x83,0x92,0x34,0x89,0x92,0xAD,0x5E,
	0xB1,0x27,0xF3,0xDC,0x51,0x7A,0xF3,0xA5,	0xDA,0x99,0x2E,0xE6,0x72,0x2A,0x79,0xE8,
	0xA4,0x1E,0x39,0x32,0x4C,0x54,0xE2,0x54,	0x69,0x51,0x21,0xA3,0x78,0xD6,0x08,0x81,
	0xB1,0xE5,0x66,0xA6,0x49,0x90,0x1A,0x2D,	0x22,0x44,0xE7,0x05,0x03,0x2E,0x90,0x30,
	0x61,0xB2,0x54,0x89,0x12,0xA3,0x22,0x09,	0x1A,0x3C,0x79,0xB3,0x05,0x0A,0x13,0x24,
	0x41,0x56,0x44,0x28,0xC0,0xC4,0x8F,0x1C,	0x2A,0x49,0x8C,0x0C,0xC9,0x21,0xE2,0xC0,
	0x80,0x3C,0x80,0xE4,0xB4,0x61,0x93,0xA6,	0xCC,0x16,0x1D,0x0D,0x12,0x04,0xFA,0x03,
	0x67,0x79,0xF3,0x30,0x54,0x38,0x48,0x98,	0x5E,0x9D,0x79,0x99,0x30,0x5C,0x46,0x58,
	0xFF,0xE0,0x6E,0xFD,0xBB,0x97,0x12,0x18,	0xC8,0x7B,0x0F,0x73,0x3E,0x3D,0xF5,0xF2,
	0xEC,0xD1,0xAB,0xBF,0xDE,0x7E,0xBE,0x79,	0xF9,0xEF,0xD7,0xD7,0xCF,0x4F,0x1F,0x7F,
	0xF7,0xFE,0xEE,0xFD,0x77,0x5F,0x80,0xF0,	0xED,0x27,0x60,0x7C,0x04,0xAE,0xD7,0x45,
	0x09,0x19,0x04,0x02,0x48,0x1C,0xF0,0x69,	0x81,0x42,0x07,0x77,0x00,0x62,0x87,0x1B,
	0xDE,0x7D,0x31,0x45,0x0D,0x27,0x24,0x01,	0x48,0x5C,0x72,0x54,0xA7,0x46,0x17,0x28,
	0x2C,0xA0,0xC4,0x1C,0x7D,0xF0,0x91,0x87,	0x60,0x6F,0xE4,0x80,0xC0,0x03,0x64,0x34,
	0x22,0x07,0x1A,0x07,0x45,0x61,0xC3,0x42,	0x0D,0x41,0xC2,0x46,0x44,0x13,0xA9,0xF0,
	0xC0,0x45,0x19,0xA5,0x35,0x88,0x6F,0x20,	0x41,0xD0,0x12,0x5A,0x70,0xE9,0xA1,0x12,
	0x4B,0x2E,0x09,0x79,0x14,0x1D,0x35,0x1D,	0xE9,0xA4,0x1E,0x7E,0x49,0x99,0x64,0x95,
	0x4D,0x5E,0x09,0x56,0x96,0x8E,0x61,0x89,	0x64,0x97,0x5B,0x7E,0x79,0x94,0x97,0x53,
	0x92,0xA9,0xA5,0x5E,0x62,0x52,0x19,0x66,	0x99,0x6B,0x9E,0x69,0xA5,0x63,0x75,0x24,
	0x76,0xD3,0x23,0x53,0xC6,0x11,0xD9,0x64,	0x95,0xC1,0x95,0xD9,0x66,0x5B,0x70,0xB2,
	0xC9,0x67,0xA1,0x29,0x42,0x48,0x1D,0xA6,	0xA1,0x76,0x89,0x25,0x94,0x48,0x12,0xC9,
	0x6B,0x09,0x2C,0x10,0x04,0x16,0x41,0xE0,	0x70,0x03,0x0D,0x2E,0x78,0x60,0x40,0x01,
	0x3E,0x94,0xA1,0xC5,0x0E,0x33,0xC8,0x10,	0x43,0x0A,0x12,0x00,0x20,0x40,0x18,0x67,
	0x68,0x51,0x85,0x14,0x4F,0x30,0x41,0x84,	0x0A,0x02,0x04,0x80,0xC6,0x19,0x58,0x9C,
	0x88,0xFA,0x44,0x13,0x4B,0x00,0xE1,0x00,	0x01,0x68,0x98,0x11,0x2B,0xAA,0xB4,0x1E,
	0x41,0x01,0x02,0xB9,0xEE,0xEA,0x04,0xAD,	0x48,0x58,0x90,0x40,0xB0,0xA7,0x0E,0xBB,
	0x44,0xB1,0x0A,0x9C,0x61,0xC6,0x15,0xB2,	0x12,0x6B,0xAC,0xB3,0xBB,0xCE,0xBA,0xAC,
	0xB1,0xB9,0x42,0xCB,0xEB,0xB5,0xC7,0xEA,	0x1A,0x2D,0xB7,0xC8,0x6E,0x5B,0x6C,0x02,
	0xCE,0x6A,0xAB,0x2C,0xB3,0xE1,0x5A,0x3B,	0xEE,0x19,0x65,0x54,0x2B,0xAD,0x02,0xD9,
	0x7E,0xBB,0xAE,0xB7,0xE2,0x5E,0x00,0xEF,	0x19,0x59,0x7C,0x4B,0x84,0x06,0x10,0x80,
	0x71,0x46,0x17,0x56,0x48,0x31,0x2C,0x12,	0x3F,0x94,0xB0,0x01,0x0F,0x66,0x98,0x21,
	0x46,0x17,0x5B,0x64,0x61,0x05,0x14,0x47,	0x80,0xA0,0x40,0x0F,0x5C,0x98,0x51,0x46,
	0x19,0x63,0x88,0xA1,0x05,0x0C,0x07,0x04,	0x04,0x00,0x3B
};
#endif //_MGINCORE_RES

